# 64bit, source https://sourceforge.net/projects/hplip/files/hplip/3.16.3/hplip-3.16.3.tar.gz

%global _exclude_files_from_autoprov %{python_sitearch}/.*\\.so$
%global _udevrulesdir /etc/udev/rules.d
%global _cups_serverbin /usr/lib/cups

Name:		hplip
Version:	3.16.11
Release:	%mkrel 1
Summary:        HP Linux Imaging and Printing Project
License:	GPLv2+ and MIT and BSD
URL:		http://hplipopensource.com/hplip-web/index.html
Group:		System/Printing
Source0:	%{name}-%{version}.tar.xz
Source1:	hpcups-update-ppds.sh
Source2:	copy-deviceids.py
Source3:	hp-sendfax.desktop
Patch001:	hplip-3.15.11-mga-automake-fix-subdir-objects.patch
Patch002:	hplip-apply-udev-rules-on-action-change.patch
Patch004:	hplip-3.15.4-hp_ipp.patch
Patch005:	hplip-3.15.11-mga-plasma-delay-startup.patch
Patch101:	hplip-pstotiff-is-rubbish.patch
Patch102:	hplip-strstr-const.patch
Patch103:	hplip-ui-optional.patch
Patch104:	hplip-no-asm.patch
Patch105:	hplip-deviceIDs-drv.patch
Patch106:	hplip-udev-rules.patch
Patch107:	hplip-retry-open.patch
Patch108:	hplip-snmp-quirks.patch
Patch109:	hplip-hpijs-marker-supply.patch
Patch110:	hplip-clear-old-state-reasons.patch
Patch111:	hplip-hpcups-sigpipe.patch
Patch112:	hplip-logdir.patch
Patch113:	hplip-bad-low-ink-warning.patch
Patch114:	hplip-deviceIDs-ppd.patch
Patch115:	hplip-ppd-ImageableArea.patch
Patch116:	hplip-scan-tmp.patch
Patch117:	hplip-log-stderr.patch
Patch118:	hplip-avahi-parsing.patch
Patch120:	hplip-dj990c-margin.patch
Patch121:	hplip-strncpy.patch
Patch122:	hplip-no-write-bytecode.patch
Patch123:	hplip-silence-ioerror.patch
Patch201:	01_rss.dpatch
Patch203:	14_charsign_fixes.dpatch
Patch204:	hplip-3.15.11-mga-85_rebuild_python_ui.dpatch
Patch206:	hplip-photosmart_b9100_support.patch
Patch207:	hplip-pjl-duplex-binding.patch
Patch219:	try_libhpmud.so.0.dpatch
Patch220:	add-lidil-two-cartridge-modes.dpatch
Patch226:	hp-systray-make-menu-title-visible-in-sni-qt-indicator.dpatch
Patch227:	hp-systray-make-menu-appear-in-sni-qt-indicator-with-kde.dpatch
Patch228:	hpaio-option-duplex.diff
Patch301:	disable_upgrade.patch
BuildRequires:	desktop-file-utils
BuildRequires:  %{_lib}cups2-devel
BuildRequires:	%{_lib}jpeg-devel
BuildRequires:	%{_lib}net-snmp-devel
BuildRequires:  %{_lib}python-devel
BuildRequires:  %{_lib}sane1-devel
BuildRequires:	%{_lib}usb1.0-devel
BuildRequires:	python-cups
BuildRoot:	%defaultbuildroot
Requires(post,postun):	%{__service}
Requires:	acl
Requires:	cups
Requires:	foomatic-filters
Requires:	ghostscript
Requires:	gnupg
Requires:	%{name}-libs = %{version}-%{release}
Requires:	net-snmp-mibs
Requires:	polkit-agent
Requires:	python-sip >= 4.1.1
Requires:	python-dbus
Requires:	python-pillow
Requires:	python-reportlab
Requires:	sane-backends-hpaio
Requires:	usbutils
Requires:	wget
Provides:	hplip-doc = %{version}-%{release}
Provides:	hplip-hpijs = %{version}-%{release}
Obsoletes:	hplip-hpijs < %{version}-%{release}

%description
The Hewlett-Packard Linux Imaging and Printing Project provides
drivers for HP printers and multi-function peripherals.

%package common
Summary:	Files needed by the HPLIP printer and scanner drivers
Group:		System/Printing
License:	GPLv2+
Requires:	udev

%description common
Files needed by the HPLIP printer and scanner drivers.

%package libs
Summary:	HPLIP libraries
Group:		System/Printing
License:	GPLv2+ and MIT
Requires:	%{name}-common = %{version}-%{release}
Requires:	python

%description libs
Libraries needed by HPLIP.

%package  gui
Summary:	HPLIP graphical tools
Group:		System/Printing
License:	BSD
Requires:	%{name} = %{version}-%{release}
Requires:	python-gobject >= 2.28.3
Requires:	python-qt4-gui

%description gui
HPLIP graphical tools.

%package -n libsane-hpaio
Summary:	SANE driver for scanners in HP's multi-function devices
Group:		System/Printing
License:	GPLv2+
Requires:	%{name}-libs = %{version}-%{release}
Requires:	sane-backends
Requires(preun): %{__service}
Provides:	sane-backends-hpaio = %{version}-%{release}

%description -n libsane-hpaio
SANE driver for scanners in HP's multi-function devices (from HPOJ).

%package devel
Summary:	HPLIP development libraries
Group:		System/Printing
License:	GPLv2+ and MIT
Requires:	%{name}-common = %{version}-%{release}
Requires:	python
Provides:	libsane-hpaio-devel = %{version}-%{release}

%description devel
Development Libraries needed by HPLIP.

%package systray
Summary:	HPLIP systray applet
Group:		System/Printing
License:	GPLv2+ and MIT
Requires:	%{name}-common = %{version}-%{release}
Requires:	%{name}-gui = %{version}-%{release}


%description systray
HPLIP systray applet that starts at login. 


%prep
%__rm -rf %{_builddir}/%{name}-%{version}
%setup -q

for ppd_file in $(grep '^diff' %{PATCH114} | cut -d " " -f 4); do gunzip ${ppd_file#*/}.gz; done
for ppd_file in $(grep '^diff' %{PATCH115} | cut -d " " -f 4); do gunzip ${ppd_file#*/}.gz; done
%apply_patches
for ppd_file in $(grep '^diff' %{PATCH115} | cut -d " " -f 4); do gzip -n ${ppd_file#*/}; done
for ppd_file in $(grep '^diff' %{PATCH114} | cut -d " " -f 4); do gzip -n ${ppd_file#*/}; done

%__chmod +x %{SOURCE2}
%__mv prnt/drv/hpijs.drv.in{,.deviceIDs-drv-hpijs}
%{SOURCE2} prnt/drv/hpcups.drv.in prnt/drv/hpijs.drv.in.deviceIDs-drv-hpijs > prnt/drv/hpijs.drv.in

%__sed -i.duplex-constraints -e 's,\(UIConstraints.* \*Duplex\),//\1,' prnt/drv/hpcups.drv.in

find -name '*.py' -print0 | xargs -0 %__sed -i.env-python -e 's,^#!/usr/bin/env python,#!/usr/bin/python,'
%__sed -i.env-python -e 's,^#!/usr/bin/env python -B,#!/usr/bin/python,' prnt/filters/hpps

for PPDGZ in ppd/hpijs/*.ppd.gz; do
  %__mv -T "$PPDGZ" "$PPDGZ.old"
  zcat "$PPDGZ.old" | sed -e 's/foomatic-rip-hplip/foomatic-rip/' | gzip -c > "$PPDGZ"
  %__rm -f "$PPDGZ.old"
done

%build
%serverbuild
touch NEWS README AUTHORS ChangeLog
%__sed -i 's|^AM_INIT_AUTOMAKE|AM_INIT_AUTOMAKE([foreign])|g' configure.in
autoreconf -ifv
%configure2_5x \
  --disable-foomatic-rip-hplip-install \
  --enable-scan-build \
  --enable-gui-build \
  --enable-fax-build \
  --enable-pp-build \
  --enable-qt4 --disable-qt3 \
  --enable-hpcups-install \
  --enable-cups-drv-install \
  --enable-foomatic-drv-install \
  --enable-cups-ppd-install \
  --enable-hpijs-install \
  --enable-policykit \
  --with-mimedir=%{_datadir}/cups/mime
%__sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g;s|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
%make

%install
%makeinstall_std

%__install -Dm 644 ip/hpip.h %{buildroot}%{_includedir}/hpip.h
%__install -m 644 ip/xform.h %{buildroot}%{_includedir}

find %{buildroot} -type f -name '*.la' -delete

%__rm -rf %{buildroot}%{_datadir}/hal/fdi

%__rm -f \
  %{buildroot}%{_sysconfdir}/sane.d/dll.conf \
  %{buildroot}%{_bindir}/{hp-doctor,hp-logcapture,hp-uninstall,hp-upgrade} \
  %{buildroot}/usr/lib/systemd/system/hplip-printer@.service \
  %{buildroot}%{_datadir}/hplip/{doctor.py,logcapture.py,uninstall.py,upgrade.py} \
  %{buildroot}%{_datadir}/cups/mime/pstotiff.types \
  %{buildroot}%{_datadir}/hplip/fax/pstotiff*

desktop-file-install --vendor='' \
  --dir=%{buildroot}%{_desktopdir} \
  --remove-category='Application' \
  --remove-category='Utility' \
  --add-category='X-MandrivaLinux-System-Configuration-Printing;' \
  --remove-key='Version' \
  %{name}.desktop

%__install -m644 %{SOURCE3} %{buildroot}%{_desktopdir}/hp-sendfax.desktop

%__install -p -m755 %{SOURCE1} %{buildroot}%{_bindir}/hpcups-update-ppds

%__mkdir_p %{buildroot}%{_sysconfdir}/sane.d/dll.d
echo hpaio > %{buildroot}%{_sysconfdir}/sane.d/dll.d/hpaio

%__install -d %{buildroot}%{_sysconfdir}/cups
%__cp -p %{buildroot}%{_datadir}/cups/mime/pstotiff.convs %{buildroot}%{_sysconfdir}/cups/pstotiff.convs

%__mkdir_p %{buildroot}%{_sbindir}
%__ln_s -f %{_bindir}/hp-setup %{buildroot}%{_sbindir}

pushd %{buildroot}%{_datadir}/%{name}
python -m compileall .
popd

%__mkdir_p %{buildroot}/run/hplip

%__mkdir_p %{buildroot}%{_localstatedir}/lib/hp/
touch %{buildroot}%{_localstatedir}/lib/hp/hplip.state

%__mkdir_p %{buildroot}%{_localstatedir}/log/hp/tmp

%clean
%__rm -rf %{buildroot}

%files
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/cups/pstotiff.convs
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/com.hp.hplip.conf
%{_udevrulesdir}/56-hpmud.rules
%dir %attr(0775,root,lp) /run/hplip
%{_bindir}/hpijs
%{_bindir}/hpcups-update-ppds
%{_bindir}/hp-*
%{_sbindir}/hp-setup
%attr(0755,root,root) %{_cups_serverbin}/backend/hp*
%{_cups_serverbin}/filter/hp*
%{_cups_serverbin}/filter/pstotiff
%doc %{_docdir}/%{name}-%{version}
%{_datadir}/hplip
%{_datadir}/cups/drv/hp/hpcups.drv
%{_datadir}/cups/drv/hp/hpijs.drv
%{_datadir}/cups/mime/pstotiff.convs
%{_datadir}/dbus-1/system-services/com.hp.hplip.service
%{_datadir}/polkit-1/actions/com.hp.hplip.policy
%{_datadir}/ppd
%{_localstatedir}/lib/hp
%dir %attr(0774,root,lp) %{_logdir}/hp
%dir %attr(1774,root,lp) %{_logdir}/hp/tmp
%exclude %{_bindir}/hp-check
%exclude %{_bindir}/hp-print
%exclude %{_bindir}/hp-systray
%exclude %{_bindir}/hp-toolbox
%exclude %{_datadir}/hplip/check.py*
%exclude %{_datadir}/hplip/print.py*
%exclude %{_datadir}/hplip/systray.py*
%exclude %{_datadir}/hplip/toolbox.py*
%exclude %{_datadir}/hplip/data/images
%exclude %{_datadir}/hplip/ui4

%files common
%defattr(-,root,root)
%dir %{_sysconfdir}/hp
%config(noreplace) %{_sysconfdir}/hp/hplip.conf
%dir %{_datadir}/hplip
%dir %{_datadir}/hplip/data
%{_datadir}/hplip/data/models

%files libs
%defattr(-,root,root)
%{_libdir}/libhpip*.so.*
%{_libdir}/libhpmud.so.*
%{_libdir}/libhpdiscovery.so.*
%{python_sitearch}/*

%files gui
%defattr(-,root,root)
%{_bindir}/hp-check
%{_bindir}/hp-print
%{_bindir}/hp-toolbox
%{_desktopdir}/*.desktop
%{_datadir}/hplip/check.py*
%{_datadir}/hplip/print.py*
%{_datadir}/hplip/systray.py*
%{_datadir}/hplip/toolbox.py*
%{_datadir}/hplip/data/images
%{_datadir}/hplip/ui4

%files -n libsane-hpaio
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/sane.d/dll.d/hpaio
%{_libdir}/sane/libsane-hpaio*.so.*

%files devel
%defattr(-,root,root)
%{_libdir}/libhp*.so
%{_libdir}/sane/libsane-hpaio.so
%{_includedir}/hpip.h
%{_includedir}/xform.h

%files systray
%defattr(-,root,root)
%{_sysconfdir}/xdg/autostart/hplip-systray.desktop
%{_bindir}/hp-systray

%post
%{_bindir}/hpcups-update-ppds &>/dev/null ||:

if [ -f /etc/init.d/cups ]; then
        %__service cups condrestart || :
fi

%postun
if [ -f /etc/init.d/cups ]; then
        %__service cups condrestart || :
fi

%post common
/sbin/udevadm trigger --subsystem-match=usb --attr-match=idVendor=03f0
/sbin/udevadm settle --timeout=15

%preun -n libsane-hpaio
if [ -f /etc/init.d/cups ]; then
        %__service cups condrestart || :
fi

%changelog
* Thu Jun 08 2017 adrianomorselli <adrianomorselli> 3.16.11-1uplos2017
- update
